	org	&h100
;
; Load/remove character set from &H9000 (for BIGECHO and BANNER)
;
; Written by: BiFi'96
;
	jp	start
	db	13,"CHARLOAD.COM v1.1 - By BiFi'96",26

start:	call	checkKill
	ld	hl,&h5c
	ld	de,fcb
	ld	bc,12
	ldir

	ld	hl,&h80
	ld	c,(hl)
	ld	b,0
	inc	c
	dec	c
	jr	z,allDone
	inc	hl

	ld	(regBc),bc
	ld	(regHl),hl
	ld	a,"/"
	cpir
	jr	nz,tryMin
	jp	po,tryMin

checkOption:	ld	a,(hl)
	cp	"B"
	jr	z,binaryFile
	cp	"b"
	jr	z,binaryFile
	jr	abort
;
tryMin:	ld	bc,(regBc)
	ld	hl,(regHl)
	ld	a,"-"
	cpir
	jp	nz,noHeader
	jp	po,noHeader
	jr	checkOption
;
binaryFile:	ld	de,&h9000-7
	jp	readChrSet
;
abort:	ld	c,9
	ld	de,tUse
	call	5

allDone:	rst	0
;
tUse:	db	"CHARLOAD <filename> [{-B|/B}]",13,10,10
	db	"-B or /B = ignore first 7 bytes (binary header)"
	db	13,10,10,"CHARLOAD KILL disables loaded set"
	db	13,10,"$"
tOrgSet:	db	0,"KILL       "

regBc:	dw	0
regHl:	dw	0
;
noHeader:	ld	de,&h9000
readChrSet:	ld	c,&h1a
	call	5
	ld	c,&h0f
	ld	de,fcb
	call	5
	pop	bc
	or	a
	jp	nz,allDone
	ld	hl,0
	ld	(fcb+12),hl
	inc	hl
	ld	(fcb+14),hl

	ld	c,&h27
	ld	de,fcb
	ld	hl,2048+7
	call	5

	ld	c,&h10
	ld	de,fcb
	call	5

	ld	a,(&hf343)
	ld	(&hf91f),a
	ld	hl,&h9000
	ld	(&hf920),hl

	jp	allDone
;
checkKill:	ld	de,&h5c
	ld	hl,tOrgSet
	ld	b,12
killChar:	ld	a,(de)
	cp	(hl)
	ret	nz
	inc	de
	inc	hl
	djnz	killChar
;
charKill:	ld	a,(&hfcc1)
	ld	(&hf91f),a
	ld	hl,4
	push	af
	call	&hc
	ld	e,a
	pop	af
	inc	hl
	push	af,de
	call	&hc
	pop	de
	ld	d,a
	pop	af
	ld	(&hf920),de
	jp	allDone
;
fcb:	ds	48,0
