	org	&hc000
;
pthPnt	equ	&hf33b
bDos	equ	&hf37d
txtTab	equ	&hf605
filTab	equ	&hf860
filNam	equ	&hf866
;
; Basics for recursive loading system. A genius idea of BiFi'96
;
; Written by: BiFi'97 - WARNING: Use for Basic only!
;
start:	ld	a,(&h2d)
	cp	3
	ld	a,129	; R800-ROM mode
	call	nc,&h180

	ld	c,&h6f	; BDOS function for checking DOS version
	call	bDos
	or	a	; Non zero?
	ret	nz	; Then it's not DOS2 (earlier)
	ld	a,b	; Check DOS-kernel version itself
	cp	2	; Set flags for checking
	jr	c,dos1

dos2:	ld	hl,(pthPnt)	; Set DOS-2 name
	ld	c,0	; Counter of Backslashes
chkBckSlsh:	ld	a,(hl)
	or	a
	inc	hl
	jr	z,chkBckSlshDn
	cp	"\"
	jr	nz,chkBckSlsh
	inc	c
	jr	chkBckSlsh
chkBckSlshDn:	xor	a
	or	c
	jr	z,dos1

	ld	de,(pthPnt)
	ld	c,&h43	; Open file handle
	ld	a,1	; Read/Only file
	call	bDos
	and	a
	jr	nz,dos2Error
	ld	hl,fcb
	ld	(hl),b





dos1:	ld	b,48	; Number of bytes to fill
	ld	hl,fcb	; Fill from the FCB
clrFcb:	ld	(hl),0	; Fill it with zeroes
	inc	hl	; Next address in the chain
	djnz	clrFcb	; Until all are done

	ld	hl,filNam	; Start of (encoded) filename
	ld	de,fcb+1	; Where to put it (FCB)
	ld	bc,11	; Length of name (always 11)
	ldir
	ld	ix,(filTab)	; Address in FILTAB in HL
	ld	a,(ix+4)	; Is called device
	ld	(fcb),a	; Put this one in the BDOS FCB

	ld	c,15	; Open file
	ld	de,fcb
	call	bDos
	and	a
	ld	de,tOpenError
	jr	nz,dos1Error
	ld	hl,0
	ld	(fcb+12),hl	; First record in file to read(?)
	ld	hl,1
	ld	(fcb+14),hl	; Set record length




;
dos1Error:	push	de
	ld	c,16
	ld	de,fcb
	call	bDos
	pop	de
	jr	prtErrLp

dos2Error:	ld	c,66h	; Explain DOS2 error
	ld	de,txtTab
	ld	b,a
	call	bDos
prtErrLp:	ld	a,(de)	; Put it onto the screen
	and	a
	ret	z
	inc	de
	call	&ha2
	jr	prtErrLp
;
tOpenError:	db	"Error opening file",0
tReadError:	db	"Error reading data",0
;
fcb	equ	$	; File Control Block starts here
;                                      ; or the DOS 2 File Handle
